import CBMSBatUniform

#coding=utf-8
import os
import sys
import datetime
import pandas as pd
from LIB.BACKEND import DBManager, Log
from sqlalchemy import create_engine
from sqlalchemy.orm import sessionmaker
import time, datetime
from urllib import parse
from LIB.MIDDLE.CellStateEstimation.Common.V1_0_1 import DBDownload
from LIB.MIDDLE.CellStateEstimation.Common.V1_0_1 import log

dbManager = DBManager.DBManager()
if __name__ == "__main__":
    # excelpath=r'D:\Platform\platform_python\data_analyze_platform\USER\spf\01qixiang\sn-20210903.xlsx'
    # SNdata_6060 = pd.read_excel(excelpath, sheet_name='科易6060')
    # SNdata_6040 = pd.read_excel(excelpath, sheet_name='科易6040')
    # SNdata_4840 = pd.read_excel(excelpath, sheet_name='科易4840')
    # SNdata_L7255 = pd.read_excel(excelpath, sheet_name='格林美-力信7255')
    # SNdata_C7255 = pd.read_excel(excelpath, sheet_name='格林美-CATL7255')
    # SNdata_U7255 = pd.read_excel(excelpath, sheet_name='优旦7255')
    # SNnums_6060=SNdata_6060['SN号'].tolist()
    # SNnums_6040=SNdata_6040['SN号'].tolist()
    # SNnums_4840=SNdata_4840['SN号'].tolist()
    # SNnums_L7255=SNdata_L7255['SN号'].tolist()
    # SNnums_C7255=SNdata_C7255['SN号'].tolist()
    # SNnums_U7255=SNdata_U7255['SN号'].tolist()
    # SNnums= SNnums_6060 + SNnums_L7255 + SNnums_C7255 + SNnums_6040 + SNnums_4840 + SNnums_U7255
    SNnums=['PK504B10100004342']

    # filepath=r'D:\Platform\platform_python\data_analyze_platform\USER\spf\01qixiang\98Download'
    # files=os.listdir(filepath)
    # files=[files[5]]

    now_time=datetime.datetime.now().strftime('%Y-%m-%d %H:%M:%S')
    now_time=datetime.datetime.strptime(now_time,'%Y-%m-%d %H:%M:%S')
    start_time=now_time-datetime.timedelta(days=20)
    end_time=str(now_time)
    start_time=str(start_time)
    start_time='2021-6-1 9:49:37'
    end_time='2021-6-15 19:49:37'

    #log信息配置
    mylog=log.Mylog('log_uniform.txt','error')
    mylog.logcfg()

    for sn in SNnums:
        print(sn)
        try:
            if 'PK500' in sn:
                celltype=1 #6040三元电芯
            elif 'PK502' in sn:
                celltype=2 #4840三元电芯
            elif 'K504B' in sn:
                celltype=99    #60ah林磷酸铁锂电芯
            elif 'MGMLXN750' in sn:
                celltype=3 #力信50ah三元电芯
            elif ('MGMCLN750' or 'UD') in sn: 
                celltype=4 #CATL 50ah三元电芯
            else:
                celltype=100
                print('SN：{}，未找到对应电池类型！！！'.format(sn))
                # continue
                # sys.exit()
            
            # df_bms= pd.read_csv(filepath+'\\'+filesname,encoding='GB18030')

            #.....................................................................读取原始数据库数据...........................................................................
            dbManager = DBManager.DBManager()
            df_data = dbManager.get_data(sn=sn, start_time=start_time, end_time=end_time, data_groups=['bms'])
            df_bms = df_data['bms']
            df_bms=df_bms.dropna(subset=['总电流[A]'])
            df_bms.reset_index(inplace=True,drop=True)     #重置索引
            # df_bms.to_csv(r'D:\Platform\platform_python\data_analyze_platform\USER\spf\01qixiang\98Download\\'+'BMS_'+sn+'.csv',encoding='GB18030')

            #.........................................................................计算一致性..............................................................................
            if not df_bms.empty:
                BatUniform=CBMSBatUniform.BatUniform(sn,celltype,df_bms)
                df_res=BatUniform.batuniform()
                df_res.to_csv(r'D:\Platform\platform_python\data_analyze_platform\USER\spf\01qixiang\99Result\\'+'CBMS_Uniform'+sn+'.csv',encoding='GB18030')
            # print('done！！！')
        
        except IndexError as e:
            print(repr(e))
            mylog.logopt(sn,e)
            pass
